Index: kernel/arch/mips32/include/types.h
===================================================================
--- kernel/arch/mips32/include/types.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/types.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,19 +36,24 @@
 #define KERN_mips32_TYPES_H_
 
-#define NULL	0
+#define NULL 0
+#define false 0
+#define true 1
 
 typedef signed char int8_t;
-typedef unsigned char uint8_t;
-
 typedef signed short int16_t;
-typedef unsigned short uint16_t;
-
-typedef unsigned long uint32_t;
 typedef signed long int32_t;
-
-typedef unsigned long long uint64_t;
 typedef signed long long int64_t;
 
+typedef unsigned char uint8_t;
+typedef unsigned short uint16_t;
+typedef unsigned long uint32_t;
+typedef unsigned long long uint64_t;
+
+typedef uint32_t size_t;
+typedef uint32_t count_t;
+typedef uint32_t index_t;
+
 typedef uint32_t uintptr_t;
+typedef uint32_t pfn_t;
 
 typedef uint32_t ipl_t;
@@ -57,7 +62,23 @@
 typedef int32_t native_t;
 
-typedef struct pte pte_t;
+typedef uint8_t bool;
+typedef uint64_t task_id_t;
+typedef uint32_t context_id_t;
 
-typedef uint32_t pfn_t;
+typedef int32_t inr_t;
+typedef int32_t devno_t;
+
+/** Page Table Entry. */
+typedef struct {
+	unsigned g : 1;			/**< Global bit. */
+	unsigned p : 1;			/**< Present bit. */
+	unsigned d : 1;			/**< Dirty bit. */
+	unsigned cacheable : 1;		/**< Cacheable bit. */
+	unsigned : 1;			/**< Unused. */
+	unsigned soft_valid : 1;	/**< Valid content even if not present. */
+	unsigned pfn : 24;		/**< Physical frame number. */
+	unsigned w : 1;			/**< Page writable bit. */
+	unsigned a : 1;			/**< Accessed bit. */
+} pte_t;
 
 #endif
Index: kernel/arch/mips32/src/cache.c
===================================================================
--- kernel/arch/mips32/src/cache.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/src/cache.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,5 +35,4 @@
 #include <arch/cache.h>
 #include <arch/exception.h>
-#include <typedefs.h>
 #include <panic.h>
 
Index: kernel/arch/mips32/src/cpu/cpu.c
===================================================================
--- kernel/arch/mips32/src/cpu/cpu.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/src/cpu/cpu.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,10 +35,6 @@
 #include <arch/cpu.h>
 #include <cpu.h>
-
 #include <arch.h>
-
 #include <arch/cp0.h>
-
-#include <typedefs.h>
 #include <print.h>	
 
Index: kernel/arch/mips32/src/ddi/ddi.c
===================================================================
--- kernel/arch/mips32/src/ddi/ddi.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/src/ddi/ddi.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #include <proc/task.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <security/cap.h>
 #include <arch.h>
Index: kernel/arch/mips32/src/drivers/msim.c
===================================================================
--- kernel/arch/mips32/src/drivers/msim.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/src/drivers/msim.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -34,9 +34,9 @@
 
 #include <interrupt.h>
+#include <ipc/irq.h>
 #include <console/chardev.h>
 #include <arch/drivers/msim.h>
 #include <arch/cp0.h>
 #include <console/console.h>
-#include <ddi/irq.h>
 #include <sysinfo/sysinfo.h>
 
Index: kernel/arch/mips32/src/drivers/serial.c
===================================================================
--- kernel/arch/mips32/src/drivers/serial.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/src/drivers/serial.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,8 +35,8 @@
 #include <interrupt.h>
 #include <arch/cp0.h>
+#include <ipc/irq.h>
 #include <arch/drivers/serial.h>
 #include <console/chardev.h>
 #include <console/console.h>
-#include <ddi/irq.h>
 
 #define SERIAL_IRQ 2
Index: kernel/arch/mips32/src/exception.c
===================================================================
--- kernel/arch/mips32/src/exception.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/src/exception.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,4 +35,5 @@
 #include <arch/exception.h>
 #include <arch/interrupt.h>
+#include <arch/mm/tlb.h>
 #include <panic.h>
 #include <arch/cp0.h>
Index: kernel/arch/mips32/src/interrupt.c
===================================================================
--- kernel/arch/mips32/src/interrupt.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/src/interrupt.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -42,5 +42,4 @@
 #include <ipc/sysipc.h>
 #include <ddi/device.h>
-#include <ddi/irq.h>
 
 #define IRQ_COUNT 8
Index: kernel/arch/mips32/src/mips32.c
===================================================================
--- kernel/arch/mips32/src/mips32.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/src/mips32.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 #include <arch/cp0.h>
 #include <arch/exception.h>
-#include <arch/asm.h>
 #include <mm/as.h>
 
Index: kernel/arch/ppc32/_link.ld.in
===================================================================
--- kernel/arch/ppc32/_link.ld.in	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/_link.ld.in	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -10,5 +10,4 @@
  */
 
-#define __ASM__
 #include <arch/boot/boot.h>
 #include <arch/mm/page.h>
Index: kernel/arch/ppc32/include/cpu.h
===================================================================
--- kernel/arch/ppc32/include/cpu.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/include/cpu.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,5 @@
 #define KERN_ppc32_CPU_H_
 
-#include <typedefs.h>
+#include <arch/asm.h>
 
 typedef struct {
Index: kernel/arch/ppc32/include/drivers/cuda.h
===================================================================
--- kernel/arch/ppc32/include/drivers/cuda.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/include/drivers/cuda.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 
 extern void cuda_init(devno_t devno, uintptr_t base, size_t size);
Index: kernel/arch/ppc32/include/drivers/pic.h
===================================================================
--- kernel/arch/ppc32/include/drivers/pic.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/include/drivers/pic.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,4 +36,6 @@
 #define KERN_ppc32_PIC_H_
 
+#include <arch/types.h>
+
 #define PIC_PENDING_LOW    8
 #define PIC_PENDING_HIGH   4
Index: kernel/arch/ppc32/include/exception.h
===================================================================
--- kernel/arch/ppc32/include/exception.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/include/exception.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,7 +37,6 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 
-struct istate {
+typedef struct {
 	uint32_t r0;
 	uint32_t r2;
@@ -78,5 +77,5 @@
 	uint32_t r12;
 	uint32_t sp;
-};
+} istate_t;
 
 static inline void istate_set_retaddr(istate_t *istate, uintptr_t retaddr)
Index: kernel/arch/ppc32/include/mm/as.h
===================================================================
--- kernel/arch/ppc32/include/mm/as.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/include/mm/as.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,8 +43,10 @@
 #define USER_ADDRESS_SPACE_END_ARCH		((unsigned long) 0x7fffffff)
 
-#define USTACK_ADDRESS_ARCH	(0x7fffffff-(PAGE_SIZE-1))
+#define USTACK_ADDRESS_ARCH	(0x7fffffff - (PAGE_SIZE - 1))
 
 typedef struct {
 } as_arch_t;
+
+#include <genarch/mm/as_pt.h>
 
 #define as_constructor_arch(as, flags)		(as != as)
Index: kernel/arch/ppc32/include/mm/memory_init.h
===================================================================
--- kernel/arch/ppc32/include/mm/memory_init.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/include/mm/memory_init.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,6 +36,4 @@
 #define KERN_ppc32_MEMORY_INIT_H_
 
-#include <typedefs.h>
-
 size_t get_memory_size(void);
 
Index: kernel/arch/ppc32/include/mm/page.h
===================================================================
--- kernel/arch/ppc32/include/mm/page.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/include/mm/page.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -105,7 +105,6 @@
 #ifndef __ASM__
 
-#include <mm/page.h>
-#include <arch/mm/frame.h>
-#include <arch/types.h>
+#include <mm/mm.h>
+#include <arch/interrupt.h>
 
 static inline int get_pt_flags(pte_t *pt, index_t i)
Index: kernel/arch/ppc32/include/mm/tlb.h
===================================================================
--- kernel/arch/ppc32/include/mm/tlb.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/include/mm/tlb.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,4 +36,6 @@
 #define KERN_ppc32_TLB_H_
 
+#include <arch/interrupt.h>
+
 typedef struct {
 	unsigned v : 1;          /**< Valid */
Index: kernel/arch/ppc32/include/types.h
===================================================================
--- kernel/arch/ppc32/include/types.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/include/types.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,4 +37,6 @@
 
 #define NULL 0
+#define false 0
+#define true 1
 
 typedef signed char int8_t;
@@ -48,4 +50,8 @@
 typedef unsigned long long uint64_t;
 
+typedef uint32_t size_t;
+typedef uint32_t count_t;
+typedef uint32_t index_t;
+
 typedef uint32_t uintptr_t;
 typedef uint32_t pfn_t;
@@ -54,4 +60,12 @@
 
 typedef uint32_t unative_t;
+typedef int32_t native_t;
+
+typedef uint8_t bool;
+typedef uint64_t task_id_t;
+typedef uint32_t context_id_t;
+
+typedef int32_t inr_t;
+typedef int32_t devno_t;
 
 /** Page Table Entry. */
Index: kernel/arch/ppc32/src/cpu/cpu.c
===================================================================
--- kernel/arch/ppc32/src/cpu/cpu.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/src/cpu/cpu.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,8 +36,5 @@
 #include <arch/cpuid.h>
 #include <cpu.h>
-
 #include <arch.h>
-
-#include <typedefs.h>
 #include <print.h>
 
Index: kernel/arch/ppc32/src/ddi/ddi.c
===================================================================
--- kernel/arch/ppc32/src/ddi/ddi.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/src/ddi/ddi.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #include <proc/task.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 /** Enable I/O space range for task.
Index: kernel/arch/ppc32/src/drivers/cuda.c
===================================================================
--- kernel/arch/ppc32/src/drivers/cuda.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/src/drivers/cuda.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -34,5 +34,5 @@
 
 #include <arch/drivers/cuda.h>
-#include <ddi/irq.h>
+#include <ipc/irq.h>
 #include <arch/asm.h>
 #include <console/console.h>
Index: kernel/arch/ppc32/src/drivers/pic.c
===================================================================
--- kernel/arch/ppc32/src/drivers/pic.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/src/drivers/pic.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -34,6 +34,6 @@
 
 
-#include <arch/asm.h>
 #include <arch/drivers/pic.h>
+#include <mm/page.h>
 #include <byteorder.h>
 #include <bitops.h>
Index: kernel/arch/ppc32/src/mm/memory_init.c
===================================================================
--- kernel/arch/ppc32/src/mm/memory_init.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/src/mm/memory_init.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,5 +35,4 @@
 #include <arch/boot/boot.h>
 #include <arch/mm/memory_init.h>
-#include <typedefs.h>
 #include <print.h>
 
Index: kernel/arch/ppc32/src/ppc32.c
===================================================================
--- kernel/arch/ppc32/src/ppc32.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc32/src/ppc32.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -33,4 +33,5 @@
  */
 
+#include <config.h>
 #include <arch.h>
 #include <arch/boot/boot.h>
Index: kernel/arch/ppc64/_link.ld.in
===================================================================
--- kernel/arch/ppc64/_link.ld.in	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/_link.ld.in	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -10,5 +10,4 @@
  */
 
-#define __ASM__
 #include <arch/boot/boot.h>
 #include <arch/mm/page.h>
Index: kernel/arch/ppc64/include/cpu.h
===================================================================
--- kernel/arch/ppc64/include/cpu.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/include/cpu.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,5 @@
 #define KERN_ppc64_CPU_H_
 
-#include <typedefs.h>
+#include <arch/asm.h>
 
 typedef struct {
Index: kernel/arch/ppc64/include/drivers/pic.h
===================================================================
--- kernel/arch/ppc64/include/drivers/pic.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/include/drivers/pic.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,4 +36,6 @@
 #define KERN_ppc64_PIC_H_
 
+#include <arch/types.h>
+
 #define PIC_PENDING_LOW    8
 #define PIC_PENDING_HIGH   4
Index: kernel/arch/ppc64/include/exception.h
===================================================================
--- kernel/arch/ppc64/include/exception.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/include/exception.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,7 +37,6 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 
-struct istate {
+typedef struct {
 	uint64_t r0;
 	uint64_t r2;
@@ -78,5 +77,5 @@
 	uint64_t r12;
 	uint64_t sp;
-};
+} istate_t;
 
 static inline void istate_set_retaddr(istate_t *istate, uintptr_t retaddr)
Index: kernel/arch/ppc64/include/mm/as.h
===================================================================
--- kernel/arch/ppc64/include/mm/as.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/include/mm/as.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,8 +43,10 @@
 #define USER_ADDRESS_SPACE_END_ARCH		((unsigned long) 0x7fffffff)
 
-#define USTACK_ADDRESS_ARCH	(0x7fffffff-(PAGE_SIZE-1))
+#define USTACK_ADDRESS_ARCH	(0x7fffffff - (PAGE_SIZE - 1))
 
 typedef struct {
 } as_arch_t;
+
+#include <genarch/mm/as_pt.h>
 
 #define as_constructor_arch(as, flags)		(as != as)
Index: kernel/arch/ppc64/include/mm/memory_init.h
===================================================================
--- kernel/arch/ppc64/include/mm/memory_init.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/include/mm/memory_init.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,6 +36,4 @@
 #define KERN_ppc64_MEMORY_INIT_H_
 
-#include <typedefs.h>
-
 size_t get_memory_size(void);
 
Index: kernel/arch/ppc64/include/mm/page.h
===================================================================
--- kernel/arch/ppc64/include/mm/page.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/include/mm/page.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -105,7 +105,6 @@
 #ifndef __ASM__
 
-#include <mm/page.h>
-#include <arch/mm/frame.h>
-#include <arch/types.h>
+#include <mm/mm.h>
+#include <arch/interrupt.h>
 
 static inline int get_pt_flags(pte_t *pt, index_t i)
Index: kernel/arch/ppc64/include/types.h
===================================================================
--- kernel/arch/ppc64/include/types.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/include/types.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,4 +37,6 @@
 
 #define NULL 0
+#define false 0
+#define true 1
 
 typedef signed char int8_t;
@@ -48,4 +50,8 @@
 typedef unsigned long uint64_t;
 
+typedef uint64_t size_t;
+typedef uint64_t count_t;
+typedef uint64_t index_t;
+
 typedef uint64_t uintptr_t;
 typedef uint64_t pfn_t;
@@ -54,4 +60,12 @@
 
 typedef uint64_t unative_t;
+typedef int64_t native_t;
+
+typedef uint8_t bool;
+typedef uint64_t task_id_t;
+typedef uint32_t context_id_t;
+
+typedef int32_t inr_t;
+typedef int32_t devno_t;
 
 /** Page Table Entry. */
Index: kernel/arch/ppc64/src/cpu/cpu.c
===================================================================
--- kernel/arch/ppc64/src/cpu/cpu.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/src/cpu/cpu.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,8 +36,5 @@
 #include <arch/cpuid.h>
 #include <cpu.h>
-
 #include <arch.h>
-
-#include <typedefs.h>
 #include <print.h>
 
Index: kernel/arch/ppc64/src/ddi/ddi.c
===================================================================
--- kernel/arch/ppc64/src/ddi/ddi.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/src/ddi/ddi.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #include <proc/task.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 /** Enable I/O space range for task.
Index: kernel/arch/ppc64/src/drivers/pic.c
===================================================================
--- kernel/arch/ppc64/src/drivers/pic.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/src/drivers/pic.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -34,6 +34,6 @@
 
 
-#include <arch/asm.h>
 #include <arch/drivers/pic.h>
+#include <mm/page.h>
 #include <byteorder.h>
 #include <bitops.h>
Index: kernel/arch/ppc64/src/mm/as.c
===================================================================
--- kernel/arch/ppc64/src/mm/as.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/src/mm/as.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -34,5 +34,5 @@
 
 #include <arch/mm/as.h>
-#include <genarch/mm/as_pt.h>
+#include <genarch/mm/page_pt.h>
 
 /** Architecture dependent address space init. */
Index: kernel/arch/ppc64/src/mm/memory_init.c
===================================================================
--- kernel/arch/ppc64/src/mm/memory_init.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ppc64/src/mm/memory_init.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,5 +35,4 @@
 #include <arch/boot/boot.h>
 #include <arch/mm/memory_init.h>
-#include <typedefs.h>
 #include <print.h>
 
Index: kernel/arch/sparc64/_link.ld.in
===================================================================
--- kernel/arch/sparc64/_link.ld.in	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/_link.ld.in	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -7,5 +7,4 @@
  */
 
-#define __LINKER__
 #include <arch/boot/boot.h>
 
Index: kernel/arch/sparc64/include/asm.h
===================================================================
--- kernel/arch/sparc64/include/asm.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/asm.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,10 +36,9 @@
 #define KERN_sparc64_ASM_H_
 
-#include <arch.h>
-#include <typedefs.h>
+#include <arch/arch.h>
 #include <arch/types.h>
+#include <align.h>
 #include <arch/register.h>
 #include <config.h>
-#include <time/clock.h>
 #include <arch/stack.h>
 
Index: kernel/arch/sparc64/include/atomic.h
===================================================================
--- kernel/arch/sparc64/include/atomic.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/atomic.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,5 +38,4 @@
 #include <arch/barrier.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 /** Atomic add operation.
Index: kernel/arch/sparc64/include/boot/boot.h
===================================================================
--- kernel/arch/sparc64/include/boot/boot.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/boot/boot.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -44,5 +44,4 @@
 #include <config.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <genarch/ofw/ofw_tree.h>
 
Index: kernel/arch/sparc64/include/cpu.h
===================================================================
--- kernel/arch/sparc64/include/cpu.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/cpu.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,4 +38,5 @@
 #include <arch/types.h>
 #include <arch/register.h>
+#include <arch/asm.h>
 
 #define MANUF_FUJITSU		0x04
Index: kernel/arch/sparc64/include/drivers/tick.h
===================================================================
--- kernel/arch/sparc64/include/drivers/tick.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/drivers/tick.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,5 @@
 #define KERN_sparc64_TICK_H_
 
-#include <typedefs.h>
+#include <arch/interrupt.h>
 
 extern void tick_init(void);
Index: kernel/arch/sparc64/include/drivers/z8530.h
===================================================================
--- kernel/arch/sparc64/include/drivers/z8530.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/drivers/z8530.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/drivers/kbd.h>
 
Index: kernel/arch/sparc64/include/interrupt.h
===================================================================
--- kernel/arch/sparc64/include/interrupt.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/interrupt.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 #define KERN_sparc64_INTERRUPT_H_
 
-#include <typedefs.h>
 #include <arch/types.h>
 #include <arch/regdef.h>
@@ -51,9 +50,9 @@
 };		
 
-struct istate {
+typedef struct {
 	uint64_t	tnpc;
 	uint64_t	tpc;
 	uint64_t	tstate;
-};
+} istate_t;
 
 static inline void istate_set_retaddr(istate_t *istate, uintptr_t retaddr)
@@ -72,7 +71,4 @@
 }
 
-
-extern void interrupt_register(int n, const char *name, iroutine f);
-
 #endif
 
Index: kernel/arch/sparc64/include/mm/as.h
===================================================================
--- kernel/arch/sparc64/include/mm/as.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/mm/as.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,7 +36,5 @@
 #define KERN_sparc64_AS_H_
 
-#ifdef CONFIG_TSB
-#include <arch/mm/tsb.h>
-#endif
+#include <arch/mm/tte.h>
 
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH	1
@@ -47,14 +45,42 @@
 #define USER_ADDRESS_SPACE_END_ARCH		(unsigned long) 0xffffffffffffffff
 
-#define USTACK_ADDRESS_ARCH	(0xffffffffffffffffULL-(PAGE_SIZE-1))
+#define USTACK_ADDRESS_ARCH	(0xffffffffffffffffULL - (PAGE_SIZE - 1))
+
+#ifdef CONFIG_TSB
+
+/** TSB Tag Target register. */
+typedef union tsb_tag_target {
+	uint64_t value;
+	struct {
+		unsigned invalid : 1;	/**< Invalidated by software. */
+		unsigned : 2;
+		unsigned context : 13;	/**< Software ASID. */
+		unsigned : 6;
+		uint64_t va_tag : 42;	/**< Virtual address bits <63:22>. */
+	} __attribute__ ((packed));
+} tsb_tag_target_t;
+
+/** TSB entry. */
+typedef struct tsb_entry {
+	tsb_tag_target_t tag;
+	tte_data_t data;
+} __attribute__ ((packed)) tsb_entry_t;
 
 typedef struct {
-#ifdef CONFIG_TSB
 	tsb_entry_t *itsb;
 	tsb_entry_t *dtsb;
-#endif /* CONFIG_TSB */
 } as_arch_t;
 
+#else
+
+typedef struct {
+} as_arch_t;
+
+#endif /* CONFIG_TSB */
+
+#include <genarch/mm/as_ht.h>
+
 #ifdef CONFIG_TSB
+#	include <arch/mm/tsb.h>
 #	define as_invalidate_translation_cache(as, page, cnt)	tsb_invalidate(as, page, cnt)
 #else
Index: kernel/arch/sparc64/include/mm/memory_init.h
===================================================================
--- kernel/arch/sparc64/include/mm/memory_init.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/mm/memory_init.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,5 @@
 #define KERN_sparc64_MEMORY_INIT_H_
 
-#include <typedefs.h>
+#include <arch/types.h>
 
 extern size_t get_memory_size(void);
Index: kernel/arch/sparc64/include/mm/mmu.h
===================================================================
--- kernel/arch/sparc64/include/mm/mmu.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/mm/mmu.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -80,8 +80,7 @@
 #include <arch/barrier.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 /** LSU Control Register. */
-union lsu_cr_reg {
+typedef union {
 	uint64_t value;
 	struct {
@@ -101,6 +100,5 @@
 		
 	} __attribute__ ((packed));
-};
-typedef union lsu_cr_reg lsu_cr_reg_t;
+} lsu_cr_reg_t;
 
 #endif /* !def __ASM__ */
Index: kernel/arch/sparc64/include/mm/page.h
===================================================================
--- kernel/arch/sparc64/include/mm/page.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/mm/page.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -47,7 +47,7 @@
 #ifndef __ASM__
 
-#include <mm/page.h>
-#include <arch/types.h>
-#include <genarch/mm/page_ht.h>
+//#include <arch/types.h>
+//#include <genarch/mm/page_ht.h>
+#include <arch/interrupt.h>
 
 extern uintptr_t physmem_base;
@@ -56,5 +56,5 @@
 #define PA2KA(x)	(((uintptr_t) (x)) - physmem_base)
 
-union page_address {
+typedef union {
 	uintptr_t address;
 	struct {
@@ -62,7 +62,5 @@
 		unsigned offset : 13;		/**< Offset. */
 	} __attribute__ ((packed));
-};
-
-typedef union page_address page_address_t;
+} page_address_t;
 
 extern void page_arch_init(void);
Index: kernel/arch/sparc64/include/mm/tlb.h
===================================================================
--- kernel/arch/sparc64/include/mm/tlb.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/mm/tlb.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -77,5 +77,4 @@
 #include <arch/barrier.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 union tlb_context_reg {
Index: kernel/arch/sparc64/include/mm/tsb.h
===================================================================
--- kernel/arch/sparc64/include/mm/tsb.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/mm/tsb.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -55,28 +55,8 @@
 #include <arch/mm/mmu.h>
 #include <arch/types.h>
-#include <typedefs.h>
-
-/** TSB Tag Target register. */
-union tsb_tag_target {
-	uint64_t value;
-	struct {
-		unsigned invalid : 1;	/**< Invalidated by software. */
-		unsigned : 2;
-		unsigned context : 13;	/**< Software ASID. */
-		unsigned : 6;
-		uint64_t va_tag : 42;	/**< Virtual address bits <63:22>. */
-	} __attribute__ ((packed));
-};
-typedef union tsb_tag_target tsb_tag_target_t;
-
-/** TSB entry. */
-struct tsb_entry {
-	tsb_tag_target_t tag;
-	tte_data_t data;
-} __attribute__ ((packed));
-typedef struct tsb_entry tsb_entry_t;
+#include <mm/as.h>
 
 /** TSB Base register. */
-union tsb_base_reg {
+typedef union tsb_base_reg {
 	uint64_t value;
 	struct {
@@ -91,6 +71,5 @@
 					 * 512 * 2^size. */
 	} __attribute__ ((packed));
-};
-typedef union tsb_base_reg tsb_base_reg_t;
+} tsb_base_reg_t;
 
 /** Read ITSB Base register.
Index: kernel/arch/sparc64/include/sparc64.h
===================================================================
--- kernel/arch/sparc64/include/sparc64.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
+++ kernel/arch/sparc64/include/sparc64.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2005 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup sparc64
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_sparc64_SPARC64_H_
+#define KERN_sparc64_SPARC64_H_
+
+#include <interrupt.h>
+
+extern void interrupt_register(int n, const char *name, iroutine f);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/sparc64/include/syscall.h
===================================================================
--- kernel/arch/sparc64/include/syscall.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/syscall.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,6 +36,6 @@
 #define KERN_sparc64_SYSCALL_H_
 
-#include <typedefs.h>
 #include <arch/types.h>
+#include <arch/interrupt.h>
 
 extern unative_t syscall(int n, istate_t *istate, unative_t a1, unative_t a2, unative_t a3, unative_t a4);
Index: kernel/arch/sparc64/include/trap/exception.h
===================================================================
--- kernel/arch/sparc64/include/trap/exception.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/trap/exception.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -59,5 +59,5 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
+#include <arch/interrupt.h>
 
 extern void dump_istate(istate_t *istate);
Index: kernel/arch/sparc64/include/trap/interrupt.h
===================================================================
--- kernel/arch/sparc64/include/trap/interrupt.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/sparc64/include/trap/interrupt.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -106,4 +106,7 @@
 
 #ifndef __ASM__
+
+#include <arch/interrupt.h>
+
 extern void interrupt(int n, istate_t *istate);
 #endif /* !def __ASM__ */
